#!/usr/bin/perl -w

# Copyright 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyLineSegments;
use MyR5Dragon;
use MyPrintwrap ':all';

# uncomment this to run the ### lines
# use Smart::Comments;


my $level = 3;
if (@ARGV) { $level = shift @ARGV; }

print "  % generated by tools/$FindBin::Script $level\n";
print "  \\newcommand{\\MyLevel}{$level}\n";

my $segments = MyLineSegments->new;

my $JAV = 0;
sub draw {
  my ($k, $x,$y) = @_;
  ### draw: "$k $x,$y"
  if ($k == 0) {
    printwrap("($x,$y),");
    $JAV++;
  } else {
    my $len = 3**($k-1);
    $segments->add($x-$len, $y, $x+$len, $y);
    $segments->add($x, $y-$len, $x, $y+$len);
    draw ($k-1, $x,     $y);
    draw ($k-1, $x-$len,$y);
    draw ($k-1, $x+$len,$y);
    draw ($k-1, $x,     $y-$len);
    draw ($k-1, $x,     $y+$len);
  }
}

$Printwrap = 2;
printwrap("\\path foreach \\p in {");
$Printwrap += 2;
my $x = 0;
foreach my $k (reverse 0 .. $level-1) {
  draw($k, $x,0);
  if ($k) {
    $x += 2*3**($k-1);
  }
}
printwrap("}");
printwrap(" { \\p node[my dot] };\n");
$segments->add(0,0, $x,0);

$Printwrap = 2;
printwrap("\\draw ");
$Printwrap += 2;
$segments->printwrap;
printwrap(";");
my $count = $segments->lines_joined_count_points;
printwrap(" % $count drawing points\n");

print "% GP-Test-Last  JAV($level) == $JAV\n";
print "  % end generated\n";
exit 0;
