#!/usr/bin/perl -w

# Copyright 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use Math::NumSeq::PlanePathTurn;

use FindBin;
use lib $FindBin::Bin;
use MyPrintwrap ':all';


print "% generated by tools/$FindBin::Script\n";
my $seq = Math::NumSeq::PlanePathTurn->new(planepath => 'QuintetCurve',
                                           turn_type => 'LSR');

printwrap_indent("% GP-DEFINE  ");
printwrap("QuartetTurn_from_path_samples = {[ ");
$Printwrap = 2;
my $max_n = 4*5*5*5+5;
foreach (1 .. $max_n) {
  my ($n,$value) = $seq->next;
  my $join = $n==$max_n ? '' : ',';
  printwrap("$value$join");
}

printwrap(" ]};\n");
print "% end generated\n";
exit 0;
